uuagc

Order

# Documentation

sem_Children :: Children -> T_Children

newtype T_Children

Constructors

T_Children ([(Identifier, Type, ChildKind)] -> [Identifier] -> [(Identifier, Identifier)] -> Identifier -> Attributes -> Map Identifier Attributes -> Map Identifier (Identifier, [Identifier]) -> Identifier -> Bool -> Attributes -> Map Identifier Attributes -> ([(Identifier, Attributes, Attributes)], Map Identifier Attributes, Map Identifier Attributes, Seq Error, [(Identifier, Type, ChildKind)], [AltAttr], Seq CRule, Seq (Identifier, Attributes), Seq (Identifier, NontermIdent), [CRule], [Identifier])) |

data Inh_Children

Constructors

Inh_Children |
Fields allfields_Inh_Children :: ![(Identifier, Type, ChildKind)] allnts_Inh_Children :: ![Identifier] attrs_Inh_Children :: ![(Identifier, Identifier)] con_Inh_Children :: !Identifier inh_Inh_Children :: !Attributes inhMap_Inh_Children :: !(Map Identifier Attributes) mergeMap_Inh_Children :: !(Map Identifier (Identifier, [Identifier])) nt_Inh_Children :: !Identifier o_unbox_Inh_Children :: !Bool syn_Inh_Children :: !Attributes synMap_Inh_Children :: !(Map Identifier Attributes)

data Syn_Children

Constructors

Syn_Children |
Fields attributes_Syn_Children :: ![(Identifier, Attributes, Attributes)] collectChildrenInhs_Syn_Children :: !(Map Identifier Attributes) collectChildrenSyns_Syn_Children :: !(Map Identifier Attributes) errors_Syn_Children :: !(Seq Error) fields_Syn_Children :: ![(Identifier, Type, ChildKind)] gathAltAttrs_Syn_Children :: ![AltAttr] gathRules_Syn_Children :: !(Seq CRule) inhs_Syn_Children :: !(Seq (Identifier, Attributes)) nts_Syn_Children :: !(Seq (Identifier, NontermIdent)) singlevisits_Syn_Children :: ![CRule] terminals_Syn_Children :: ![Identifier]

wrap_Children :: T_Children -> Inh_Children -> Syn_Children

sem_Children_Cons :: T_Child -> T_Children -> T_Children

sem_Children_Nil :: T_Children

sem_Expression :: Expression -> T_Expression

newtype T_Expression

Constructors

T_Expression ([(Identifier, Type, ChildKind)] -> [Identifier] -> [(Identifier, Identifier)] -> Identifier -> Map Identifier (Identifier, [Identifier]) -> Identifier -> (Set (Identifier, Identifier), Expression, Seq Error, [String], [(Identifier, Identifier)], [Identifier], [Identifier])) |

data Inh_Expression

Constructors

Inh_Expression |
Fields allfields_Inh_Expression :: ![(Identifier, Type, ChildKind)] allnts_Inh_Expression :: ![Identifier] attrs_Inh_Expression :: ![(Identifier, Identifier)] con_Inh_Expression :: !Identifier mergeMap_Inh_Expression :: !(Map Identifier (Identifier, [Identifier])) nt_Inh_Expression :: !Identifier

data Syn_Expression

Constructors

Syn_Expression |
Fields allRhsVars_Syn_Expression :: !(Set (Identifier, Identifier)) copy_Syn_Expression :: !Expression errors_Syn_Expression :: !(Seq Error) textLines_Syn_Expression :: ![String] usedAttrs_Syn_Expression :: ![(Identifier, Identifier)] usedFields_Syn_Expression :: ![Identifier] usedLocals_Syn_Expression :: ![Identifier]

wrap_Expression :: T_Expression -> Inh_Expression -> Syn_Expression

sem_Expression_Expression :: Pos -> [HsToken] -> T_Expression

sem_Grammar :: Grammar -> T_Grammar

newtype T_Grammar

Constructors

T_Grammar (Options -> (Seq Error, Int, Int, CGrammar)) |

data Inh_Grammar

Constructors

Inh_Grammar |
Fields options_Inh_Grammar :: !Options

data Syn_Grammar

Constructors

Syn_Grammar |
Fields errors_Syn_Grammar :: !(Seq Error) nAutoRules_Syn_Grammar :: !Int nExplicitRules_Syn_Grammar :: !Int output_Syn_Grammar :: !CGrammar

wrap_Grammar :: T_Grammar -> Inh_Grammar -> Syn_Grammar

sem_Grammar_Grammar :: TypeSyns -> UseMap -> Derivings -> Set NontermIdent -> T_Nonterminals -> PragmaMap -> AttrOrderMap -> ParamMap -> ContextMap -> QuantMap -> UniqueMap -> Map NontermIdent (Map ConstructorIdent (Map Identifier [Expression])) -> Map NontermIdent (Map ConstructorIdent (Map Identifier [Expression])) -> Map NontermIdent (Map ConstructorIdent (Map Identifier (Identifier, [Identifier], Expression))) -> T_Grammar

sem_Nonterminal :: Nonterminal -> T_Nonterminal

newtype T_Nonterminal

Constructors

T_Nonterminal (Int -> [Identifier] -> Map NontermIdent (Map ConstructorIdent (Map Identifier [Expression])) -> CInterfaceMap -> CVisitsMap -> Map Identifier Attributes -> AttrOrderMap -> Map NontermIdent (Map ConstructorIdent (Map Identifier (Identifier, [Identifier]))) -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> String -> Map Identifier Attributes -> Int -> (Int, Seq Edge, Seq (Int, Int, Int), Seq Edge, CNonterminal, Seq Edge, Seq Error, Map Identifier Attributes, Seq Edge, Seq Edge, Int, Int, [(NontermIdent, [ConstructorIdent])], Seq (Vertex, NTAttr), Seq (Vertex, CRule), Map Identifier Attributes, Int)) |

data Inh_Nonterminal

Constructors

Inh_Nonterminal |
Fields acount_Inh_Nonterminal :: !Int allnts_Inh_Nonterminal :: ![Identifier] aroundMap_Inh_Nonterminal :: !(Map NontermIdent (Map ConstructorIdent (Map Identifier [Expression]))) cInterfaceMap_Inh_Nonterminal :: !CInterfaceMap cVisitsMap_Inh_Nonterminal :: !CVisitsMap inhMap_Inh_Nonterminal :: !(Map Identifier Attributes) manualAttrDepMap_Inh_Nonterminal :: !AttrOrderMap mergeMap_Inh_Nonterminal :: !(Map NontermIdent (Map ConstructorIdent (Map Identifier (Identifier, [Identifier])))) o_case_Inh_Nonterminal :: !Bool o_cata_Inh_Nonterminal :: !Bool o_data_Inh_Nonterminal :: !Bool o_dovisit_Inh_Nonterminal :: !Bool o_newtypes_Inh_Nonterminal :: !Bool o_rename_Inh_Nonterminal :: !Bool o_sem_Inh_Nonterminal :: !Bool o_sig_Inh_Nonterminal :: !Bool o_unbox_Inh_Nonterminal :: !Bool o_wantvisit_Inh_Nonterminal :: !Bool prefix_Inh_Nonterminal :: !String synMap_Inh_Nonterminal :: !(Map Identifier Attributes) vcount_Inh_Nonterminal :: !Int

data Syn_Nonterminal

Constructors

Syn_Nonterminal |
Fields acount_Syn_Nonterminal :: !Int additionalDep_Syn_Nonterminal :: !(Seq Edge) aranges_Syn_Nonterminal :: !(Seq (Int, Int, Int)) aroundDep_Syn_Nonterminal :: !(Seq Edge) cNonterminal_Syn_Nonterminal :: !CNonterminal directDep_Syn_Nonterminal :: !(Seq Edge) errors_Syn_Nonterminal :: !(Seq Error) inhMap'_Syn_Nonterminal :: !(Map Identifier Attributes) instDep_Syn_Nonterminal :: !(Seq Edge) mergeDep_Syn_Nonterminal :: !(Seq Edge) nAutoRules_Syn_Nonterminal :: !Int nExplicitRules_Syn_Nonterminal :: !Int nonts_Syn_Nonterminal :: ![(NontermIdent, [ConstructorIdent])] ntattrs_Syn_Nonterminal :: !(Seq (Vertex, NTAttr)) rules_Syn_Nonterminal :: !(Seq (Vertex, CRule)) synMap'_Syn_Nonterminal :: !(Map Identifier Attributes) vcount_Syn_Nonterminal :: !Int

wrap_Nonterminal :: T_Nonterminal -> Inh_Nonterminal -> Syn_Nonterminal

sem_Nonterminal_Nonterminal :: NontermIdent -> [Identifier] -> Attributes -> Attributes -> T_Productions -> T_Nonterminal

sem_Nonterminals :: Nonterminals -> T_Nonterminals

newtype T_Nonterminals

Constructors

T_Nonterminals (Int -> [Identifier] -> Map NontermIdent (Map ConstructorIdent (Map Identifier [Expression])) -> CInterfaceMap -> CVisitsMap -> Map Identifier Attributes -> AttrOrderMap -> Map NontermIdent (Map ConstructorIdent (Map Identifier (Identifier, [Identifier]))) -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> String -> Map Identifier Attributes -> Int -> (Int, Seq Edge, Seq (Int, Int, Int), Seq Edge, CNonterminals, Seq Edge, Seq Error, Map Identifier Attributes, Seq Edge, Seq Edge, Int, Int, [(NontermIdent, [ConstructorIdent])], Seq (Vertex, NTAttr), Seq (Vertex, CRule), Map Identifier Attributes, Int)) |

data Inh_Nonterminals

Constructors

Inh_Nonterminals |
Fields acount_Inh_Nonterminals :: !Int allnts_Inh_Nonterminals :: ![Identifier] aroundMap_Inh_Nonterminals :: !(Map NontermIdent (Map ConstructorIdent (Map Identifier [Expression]))) cInterfaceMap_Inh_Nonterminals :: !CInterfaceMap cVisitsMap_Inh_Nonterminals :: !CVisitsMap inhMap_Inh_Nonterminals :: !(Map Identifier Attributes) manualAttrDepMap_Inh_Nonterminals :: !AttrOrderMap mergeMap_Inh_Nonterminals :: !(Map NontermIdent (Map ConstructorIdent (Map Identifier (Identifier, [Identifier])))) o_case_Inh_Nonterminals :: !Bool o_cata_Inh_Nonterminals :: !Bool o_data_Inh_Nonterminals :: !Bool o_dovisit_Inh_Nonterminals :: !Bool o_newtypes_Inh_Nonterminals :: !Bool o_rename_Inh_Nonterminals :: !Bool o_sem_Inh_Nonterminals :: !Bool o_sig_Inh_Nonterminals :: !Bool o_unbox_Inh_Nonterminals :: !Bool o_wantvisit_Inh_Nonterminals :: !Bool prefix_Inh_Nonterminals :: !String synMap_Inh_Nonterminals :: !(Map Identifier Attributes) vcount_Inh_Nonterminals :: !Int

data Syn_Nonterminals

Constructors

Syn_Nonterminals |
Fields acount_Syn_Nonterminals :: !Int additionalDep_Syn_Nonterminals :: !(Seq Edge) aranges_Syn_Nonterminals :: !(Seq (Int, Int, Int)) aroundDep_Syn_Nonterminals :: !(Seq Edge) cNonterminals_Syn_Nonterminals :: !CNonterminals directDep_Syn_Nonterminals :: !(Seq Edge) errors_Syn_Nonterminals :: !(Seq Error) inhMap'_Syn_Nonterminals :: !(Map Identifier Attributes) instDep_Syn_Nonterminals :: !(Seq Edge) mergeDep_Syn_Nonterminals :: !(Seq Edge) nAutoRules_Syn_Nonterminals :: !Int nExplicitRules_Syn_Nonterminals :: !Int nonts_Syn_Nonterminals :: ![(NontermIdent, [ConstructorIdent])] ntattrs_Syn_Nonterminals :: !(Seq (Vertex, NTAttr)) rules_Syn_Nonterminals :: !(Seq (Vertex, CRule)) synMap'_Syn_Nonterminals :: !(Map Identifier Attributes) vcount_Syn_Nonterminals :: !Int

wrap_Nonterminals :: T_Nonterminals -> Inh_Nonterminals -> Syn_Nonterminals

sem_Nonterminals_Cons :: T_Nonterminal -> T_Nonterminals -> T_Nonterminals

sem_Nonterminals_Nil :: T_Nonterminals

sem_Pattern :: Pattern -> T_Pattern

newtype T_Pattern

Constructors

T_Pattern (Map Identifier Type -> Map AltAttr Vertex -> Identifier -> Attributes -> Identifier -> Attributes -> (Pattern, Seq Error, [AltAttr], [Identifier], [Identifier], [(Identifier, Identifier, Bool)])) |

data Inh_Pattern

Constructors

Inh_Pattern |
Fields allTypeSigs_Inh_Pattern :: !(Map Identifier Type) altAttrs_Inh_Pattern :: !(Map AltAttr Vertex) con_Inh_Pattern :: !Identifier inh_Inh_Pattern :: !Attributes nt_Inh_Pattern :: !Identifier syn_Inh_Pattern :: !Attributes

data Syn_Pattern

Constructors

Syn_Pattern |
Fields copy_Syn_Pattern :: !Pattern errors_Syn_Pattern :: !(Seq Error) gathAltAttrs_Syn_Pattern :: ![AltAttr] instVars_Syn_Pattern :: ![Identifier] locVars_Syn_Pattern :: ![Identifier] patternAttrs_Syn_Pattern :: ![(Identifier, Identifier, Bool)]

wrap_Pattern :: T_Pattern -> Inh_Pattern -> Syn_Pattern

sem_Pattern_Alias :: Identifier -> Identifier -> T_Pattern -> T_Pattern

sem_Pattern_Constr :: ConstructorIdent -> T_Patterns -> T_Pattern

sem_Pattern_Irrefutable :: T_Pattern -> T_Pattern

sem_Pattern_Product :: Pos -> T_Patterns -> T_Pattern

sem_Pattern_Underscore :: Pos -> T_Pattern

sem_Patterns :: Patterns -> T_Patterns

newtype T_Patterns

Constructors

T_Patterns (Map Identifier Type -> Map AltAttr Vertex -> Identifier -> Attributes -> Identifier -> Attributes -> (Patterns, Seq Error, [AltAttr], [Identifier], [Identifier], [(Identifier, Identifier, Bool)])) |

data Inh_Patterns

Constructors

Inh_Patterns |
Fields allTypeSigs_Inh_Patterns :: !(Map Identifier Type) altAttrs_Inh_Patterns :: !(Map AltAttr Vertex) con_Inh_Patterns :: !Identifier inh_Inh_Patterns :: !Attributes nt_Inh_Patterns :: !Identifier syn_Inh_Patterns :: !Attributes

data Syn_Patterns

Constructors

Syn_Patterns |
Fields copy_Syn_Patterns :: !Patterns errors_Syn_Patterns :: !(Seq Error) gathAltAttrs_Syn_Patterns :: ![AltAttr] instVars_Syn_Patterns :: ![Identifier] locVars_Syn_Patterns :: ![Identifier] patternAttrs_Syn_Patterns :: ![(Identifier, Identifier, Bool)]

wrap_Patterns :: T_Patterns -> Inh_Patterns -> Syn_Patterns

sem_Patterns_Cons :: T_Pattern -> T_Patterns -> T_Patterns

sem_Patterns_Nil :: T_Patterns

sem_Production :: Production -> T_Production

newtype T_Production

Constructors

T_Production ([Identifier] -> Map ConstructorIdent (Map Identifier [Expression]) -> CVisitsMap -> Attributes -> Map Identifier Attributes -> AttrOrderMap -> Map ConstructorIdent (Map Identifier (Identifier, [Identifier])) -> Identifier -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> String -> Attributes -> Map Identifier Attributes -> Int -> (Seq Edge, Seq Edge, CProduction, [ConstructorIdent], Seq Edge, Seq Error, Seq Edge, Seq Edge, Int, Int, Seq (Vertex, CRule), Int)) |

data Inh_Production

Constructors

Inh_Production |
Fields allnts_Inh_Production :: ![Identifier] aroundMap_Inh_Production :: !(Map ConstructorIdent (Map Identifier [Expression])) cVisitsMap_Inh_Production :: !CVisitsMap inh_Inh_Production :: !Attributes inhMap_Inh_Production :: !(Map Identifier Attributes) manualAttrDepMap_Inh_Production :: !AttrOrderMap mergeMap_Inh_Production :: !(Map ConstructorIdent (Map Identifier (Identifier, [Identifier]))) nt_Inh_Production :: !Identifier o_case_Inh_Production :: !Bool o_cata_Inh_Production :: !Bool o_dovisit_Inh_Production :: !Bool o_newtypes_Inh_Production :: !Bool o_rename_Inh_Production :: !Bool o_sem_Inh_Production :: !Bool o_sig_Inh_Production :: !Bool o_unbox_Inh_Production :: !Bool o_wantvisit_Inh_Production :: !Bool prefix_Inh_Production :: !String syn_Inh_Production :: !Attributes synMap_Inh_Production :: !(Map Identifier Attributes) vcount_Inh_Production :: !Int

data Syn_Production

Constructors

Syn_Production |
Fields additionalDep_Syn_Production :: !(Seq Edge) aroundDep_Syn_Production :: !(Seq Edge) cProduction_Syn_Production :: !CProduction cons_Syn_Production :: ![ConstructorIdent] directDep_Syn_Production :: !(Seq Edge) errors_Syn_Production :: !(Seq Error) instDep_Syn_Production :: !(Seq Edge) mergeDep_Syn_Production :: !(Seq Edge) nAutoRules_Syn_Production :: !Int nExplicitRules_Syn_Production :: !Int rules_Syn_Production :: !(Seq (Vertex, CRule)) vcount_Syn_Production :: !Int

wrap_Production :: T_Production -> Inh_Production -> Syn_Production

sem_Production_Production :: ConstructorIdent -> [Identifier] -> [Type] -> T_Children -> T_Rules -> T_TypeSigs -> MaybeMacro -> T_Production

sem_Productions :: Productions -> T_Productions

newtype T_Productions

Constructors

T_Productions ([Identifier] -> Map ConstructorIdent (Map Identifier [Expression]) -> CVisitsMap -> Attributes -> Map Identifier Attributes -> AttrOrderMap -> Map ConstructorIdent (Map Identifier (Identifier, [Identifier])) -> Identifier -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> String -> Attributes -> Map Identifier Attributes -> Int -> (Seq Edge, Seq Edge, CProductions, [ConstructorIdent], Seq Edge, Seq Error, Seq Edge, Seq Edge, Int, Int, Seq (Vertex, CRule), Int)) |

data Inh_Productions

Constructors

Inh_Productions |
Fields allnts_Inh_Productions :: ![Identifier] aroundMap_Inh_Productions :: !(Map ConstructorIdent (Map Identifier [Expression])) cVisitsMap_Inh_Productions :: !CVisitsMap inh_Inh_Productions :: !Attributes inhMap_Inh_Productions :: !(Map Identifier Attributes) manualAttrDepMap_Inh_Productions :: !AttrOrderMap mergeMap_Inh_Productions :: !(Map ConstructorIdent (Map Identifier (Identifier, [Identifier]))) nt_Inh_Productions :: !Identifier o_case_Inh_Productions :: !Bool o_cata_Inh_Productions :: !Bool o_dovisit_Inh_Productions :: !Bool o_newtypes_Inh_Productions :: !Bool o_rename_Inh_Productions :: !Bool o_sem_Inh_Productions :: !Bool o_sig_Inh_Productions :: !Bool o_unbox_Inh_Productions :: !Bool o_wantvisit_Inh_Productions :: !Bool prefix_Inh_Productions :: !String syn_Inh_Productions :: !Attributes synMap_Inh_Productions :: !(Map Identifier Attributes) vcount_Inh_Productions :: !Int

data Syn_Productions

Constructors

Syn_Productions |
Fields additionalDep_Syn_Productions :: !(Seq Edge) aroundDep_Syn_Productions :: !(Seq Edge) cProductions_Syn_Productions :: !CProductions cons_Syn_Productions :: ![ConstructorIdent] directDep_Syn_Productions :: !(Seq Edge) errors_Syn_Productions :: !(Seq Error) instDep_Syn_Productions :: !(Seq Edge) mergeDep_Syn_Productions :: !(Seq Edge) nAutoRules_Syn_Productions :: !Int nExplicitRules_Syn_Productions :: !Int rules_Syn_Productions :: !(Seq (Vertex, CRule)) vcount_Syn_Productions :: !Int

wrap_Productions :: T_Productions -> Inh_Productions -> Syn_Productions

sem_Productions_Cons :: T_Production -> T_Productions -> T_Productions

sem_Productions_Nil :: T_Productions

sem_Rule :: Rule -> T_Rule

newtype T_Rule

Constructors

T_Rule (Map Identifier Type -> [(Identifier, Type, ChildKind)] -> [Identifier] -> Map AltAttr Vertex -> [(Identifier, Identifier)] -> Map Identifier Attributes -> Map Identifier NontermIdent -> Identifier -> Attributes -> Map Identifier Attributes -> Map Identifier (Identifier, [Identifier]) -> Identifier -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> String -> Attributes -> Map Identifier Attributes -> (Seq Edge, Seq Error, [AltAttr], Seq CRule, Seq Edge, [Identifier], [Identifier], Int, Int)) |

data Inh_Rule

Constructors

Inh_Rule |
Fields allTypeSigs_Inh_Rule :: !(Map Identifier Type) allfields_Inh_Rule :: ![(Identifier, Type, ChildKind)] allnts_Inh_Rule :: ![Identifier] altAttrs_Inh_Rule :: !(Map AltAttr Vertex) attrs_Inh_Rule :: ![(Identifier, Identifier)] childInhs_Inh_Rule :: !(Map Identifier Attributes) childNts_Inh_Rule :: !(Map Identifier NontermIdent) con_Inh_Rule :: !Identifier inh_Inh_Rule :: !Attributes inhsOfChildren_Inh_Rule :: !(Map Identifier Attributes) mergeMap_Inh_Rule :: !(Map Identifier (Identifier, [Identifier])) nt_Inh_Rule :: !Identifier o_case_Inh_Rule :: !Bool o_cata_Inh_Rule :: !Bool o_dovisit_Inh_Rule :: !Bool o_newtypes_Inh_Rule :: !Bool o_rename_Inh_Rule :: !Bool o_sem_Inh_Rule :: !Bool o_sig_Inh_Rule :: !Bool o_wantvisit_Inh_Rule :: !Bool prefix_Inh_Rule :: !String syn_Inh_Rule :: !Attributes synsOfChildren_Inh_Rule :: !(Map Identifier Attributes)

data Syn_Rule

Constructors

Syn_Rule |
Fields directDep_Syn_Rule :: !(Seq Edge) errors_Syn_Rule :: !(Seq Error) gathAltAttrs_Syn_Rule :: ![AltAttr] gathRules_Syn_Rule :: !(Seq CRule) instDep_Syn_Rule :: !(Seq Edge) instVars_Syn_Rule :: ![Identifier] locVars_Syn_Rule :: ![Identifier] nAutoRules_Syn_Rule :: !Int nExplicitRules_Syn_Rule :: !Int

wrap_Rule :: T_Rule -> Inh_Rule -> Syn_Rule

sem_Rule_Rule :: Maybe Identifier -> T_Pattern -> T_Expression -> Bool -> String -> Bool -> Bool -> Bool -> Maybe Error -> Bool -> T_Rule

sem_Rules :: Rules -> T_Rules

newtype T_Rules

Constructors

T_Rules (Map Identifier Type -> [(Identifier, Type, ChildKind)] -> [Identifier] -> Map AltAttr Vertex -> [(Identifier, Identifier)] -> Map Identifier Attributes -> Map Identifier NontermIdent -> Identifier -> Attributes -> Map Identifier Attributes -> Map Identifier (Identifier, [Identifier]) -> Identifier -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> Bool -> String -> Attributes -> Map Identifier Attributes -> (Seq Edge, Seq Error, [AltAttr], Seq CRule, Seq Edge, [Identifier], [Identifier], Int, Int)) |

data Inh_Rules

Constructors

Inh_Rules |
Fields allTypeSigs_Inh_Rules :: !(Map Identifier Type) allfields_Inh_Rules :: ![(Identifier, Type, ChildKind)] allnts_Inh_Rules :: ![Identifier] altAttrs_Inh_Rules :: !(Map AltAttr Vertex) attrs_Inh_Rules :: ![(Identifier, Identifier)] childInhs_Inh_Rules :: !(Map Identifier Attributes) childNts_Inh_Rules :: !(Map Identifier NontermIdent) con_Inh_Rules :: !Identifier inh_Inh_Rules :: !Attributes inhsOfChildren_Inh_Rules :: !(Map Identifier Attributes) mergeMap_Inh_Rules :: !(Map Identifier (Identifier, [Identifier])) nt_Inh_Rules :: !Identifier o_case_Inh_Rules :: !Bool o_cata_Inh_Rules :: !Bool o_dovisit_Inh_Rules :: !Bool o_newtypes_Inh_Rules :: !Bool o_rename_Inh_Rules :: !Bool o_sem_Inh_Rules :: !Bool o_sig_Inh_Rules :: !Bool o_wantvisit_Inh_Rules :: !Bool prefix_Inh_Rules :: !String syn_Inh_Rules :: !Attributes synsOfChildren_Inh_Rules :: !(Map Identifier Attributes)

data Syn_Rules

Constructors

Syn_Rules |
Fields directDep_Syn_Rules :: !(Seq Edge) errors_Syn_Rules :: !(Seq Error) gathAltAttrs_Syn_Rules :: ![AltAttr] gathRules_Syn_Rules :: !(Seq CRule) instDep_Syn_Rules :: !(Seq Edge) instVars_Syn_Rules :: ![Identifier] locVars_Syn_Rules :: ![Identifier] nAutoRules_Syn_Rules :: !Int nExplicitRules_Syn_Rules :: !Int

wrap_Rules :: T_Rules -> Inh_Rules -> Syn_Rules

sem_Rules_Cons :: T_Rule -> T_Rules -> T_Rules

sem_Rules_Nil :: T_Rules

sem_TypeSig :: TypeSig -> T_TypeSig

newtype T_TypeSig

Constructors

T_TypeSig (Map Identifier Type -> Map Identifier Type) |

data Inh_TypeSig

Constructors

Inh_TypeSig |
Fields typeSigs_Inh_TypeSig :: !(Map Identifier Type)

data Syn_TypeSig

Constructors

Syn_TypeSig |
Fields typeSigs_Syn_TypeSig :: !(Map Identifier Type)

wrap_TypeSig :: T_TypeSig -> Inh_TypeSig -> Syn_TypeSig

sem_TypeSig_TypeSig :: Identifier -> Type -> T_TypeSig

sem_TypeSigs :: TypeSigs -> T_TypeSigs

newtype T_TypeSigs

Constructors

T_TypeSigs (Map Identifier Type -> Map Identifier Type) |

data Inh_TypeSigs

Constructors

Inh_TypeSigs |
Fields typeSigs_Inh_TypeSigs :: !(Map Identifier Type)

data Syn_TypeSigs

Constructors

Syn_TypeSigs |
Fields typeSigs_Syn_TypeSigs :: !(Map Identifier Type)

wrap_TypeSigs :: T_TypeSigs -> Inh_TypeSigs -> Syn_TypeSigs

sem_TypeSigs_Cons :: T_TypeSig -> T_TypeSigs -> T_TypeSigs

sem_TypeSigs_Nil :: T_TypeSigs

sem_Child :: Child -> T_Child

newtype T_Child

Constructors

T_Child ([(Identifier, Type, ChildKind)] -> [Identifier] -> [(Identifier, Identifier)] -> Identifier -> Attributes -> Map Identifier Attributes -> Map Identifier (Identifier, [Identifier]) -> Identifier -> Bool -> Attributes -> Map Identifier Attributes -> ([(Identifier, Attributes, Attributes)], Map Identifier Attributes, Map Identifier Attributes, Seq Error, (Identifier, Type, ChildKind), [AltAttr], Seq CRule, Seq (Identifier, Attributes), Seq (Identifier, NontermIdent), [CRule], [Identifier])) |

data Inh_Child

Constructors

Inh_Child |
Fields allfields_Inh_Child :: ![(Identifier, Type, ChildKind)] allnts_Inh_Child :: ![Identifier] attrs_Inh_Child :: ![(Identifier, Identifier)] con_Inh_Child :: !Identifier inh_Inh_Child :: !Attributes inhMap_Inh_Child :: !(Map Identifier Attributes) mergeMap_Inh_Child :: !(Map Identifier (Identifier, [Identifier])) nt_Inh_Child :: !Identifier o_unbox_Inh_Child :: !Bool syn_Inh_Child :: !Attributes synMap_Inh_Child :: !(Map Identifier Attributes)

data Syn_Child

Constructors

Syn_Child |
Fields attributes_Syn_Child :: ![(Identifier, Attributes, Attributes)] collectChildrenInhs_Syn_Child :: !(Map Identifier Attributes) collectChildrenSyns_Syn_Child :: !(Map Identifier Attributes) errors_Syn_Child :: !(Seq Error) field_Syn_Child :: !(Identifier, Type, ChildKind) gathAltAttrs_Syn_Child :: ![AltAttr] gathRules_Syn_Child :: !(Seq CRule) inhs_Syn_Child :: !(Seq (Identifier, Attributes)) nts_Syn_Child :: !(Seq (Identifier, NontermIdent)) singlevisits_Syn_Child :: ![CRule] terminals_Syn_Child :: ![Identifier]

wrap_Child :: T_Child -> Inh_Child -> Syn_Child

sem_Child_Child :: Identifier -> Type -> ChildKind -> T_Child

findWithErr1 :: (Ord k, Show k) => String -> k -> Map k a -> a

findWithErr2 :: (Ord k, Show k, Show a) => k -> Map k a -> a

startsWith :: String -> String -> Bool

getNtName :: Type -> NontermIdent

data AltAttr

Constructors

AltAttr Identifier Identifier Bool |

Instances

Eq AltAttr |
Ord AltAttr |
Show AltAttr |

haskellTupel :: [Type] -> Maybe Type

showPath :: Table CRule -> [Vertex] -> [String]

showPathLocal :: Table CRule -> [Vertex] -> [String]

limitTo :: Int -> [String] -> [String]

showPathNice :: Table CRule -> [Vertex] -> [String]

localCycleErr :: Table CRule -> Bool -> Route -> Error

instCycleErr :: Table CRule -> Bool -> Route -> Error

directCycleErrs :: Table NTAttr -> Table CRule -> Bool -> [EdgeRoutes] -> [Error]

inducedCycleErrs :: Table NTAttr -> Table CRule -> CInterfaceMap -> [EdgeRoutes] -> [Error]